self.qsaObserver = (function (exports) {
  'use strict';

  var filter = [].filter;

  var elements = function elements(element) {
    return 'querySelectorAll' in element;
  };

  var index = (function (options) {
    var cache = options.cache,
        query = options.query,
        root = options.root;

    var callback = function callback(records) {
      if (query.length) {
        for (var i = 0, length = records.length; i < length; i++) {
          var _records$i = records[i],
              addedNodes = _records$i.addedNodes,
              removedNodes = _records$i.removedNodes;

          _parse(filter.call(addedNodes, elements), true, new Set());

          _parse(filter.call(removedNodes, elements), false, new Set());
        }
      }
    };

    var matches = function matches(element) {
      return element.matches || element.webkitMatchesSelector || element.msMatchesSelector;
    };

    var _parse = function parse(elements, connected, set) {
      for (var element, i = 0, length = elements.length; i < length; i++) {
        if (!set.has(element = elements[i])) {
          set.add(element);
          if (cache.has(element)) options.update(element, connected);else if (connected) setup(element);

          _parse(element.querySelectorAll(query), connected, set);
        }
      }
    };

    var setup = function setup(element) {
      for (var m = matches(element), i = 0, length = query.length; i < length; i++) {
        if (m.call(element, query[i])) options.setup(element, query[i]);
      }
    };

    var observer = new MutationObserver(callback);
    observer.observe(root || document, {
      childList: true,
      subtree: true
    });
    if (query.length) _parse((root || document).querySelectorAll(query), true, new Set());
    return {
      flush: function flush() {
        callback(observer.takeRecords());
      },
      matches: matches,
      observer: observer,
      parse: function parse(elements) {
        var connected = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;

        _parse(elements, connected, new Set());
      }
    };
  });

  exports.default = index;

  return exports;

}({}).default);
